<?php

use UnicaenCode\Form\AbstractForm;
use UnicaenCode\Form\ElementMaker;
use UnicaenCode\Util;

/**
 * @var $this       \Application\View\Renderer\PhpRenderer
 * @var $controller \Zend\Mvc\Controller\AbstractController
 * @var $container  \Interop\Container\ContainerInterface
 * @var $viewName   string
 * @var $viewFile   string
 */

$cg = \UnicaenCode\Util::codeGenerator();

$cg->start('Génération d\'une Classmap pour optimiser l\'autoload');

$form = new \UnicaenCode\Form\CustomForm();

$form->addSelectModule(
    'module', 'Module concerné'
);


if (empty($params = $cg->formPublish($form))) return;

$moduleName = $form->get('module')->getValue();
$module     = Util::introspection()->getModule($moduleName);

$params['template'] = 'autoload_classmap';
$params['filename'] = $module['relPath'] . '/autoload_classmap.php';

$map = Util::introspection()->getClasses($module['namespace']);

$mc = 0;
foreach ($map as $c => $f) {
    $lc = strlen($c);
    if ($lc > $mc) $mc = $lc;
}
$php = '';
foreach ($map as $c => $f) {
    $php .= "    " . str_pad("'$c'", $mc + 2, ' ') . " => __DIR__ . '$f',\n";
}

$params['map'] = trim($php);

$cg->end($params);