<?php

use UnicaenCode\Util;

/**
 * @var $this       \Application\View\Renderer\PhpRenderer
 * @var $controller \Zend\Mvc\Controller\AbstractController
 * @var $container  \Interop\Container\ContainerInterface
 * @var $viewName   string
 * @var $viewFile   string
 */

$cg = \UnicaenCode\Util::codeGenerator();

$cg->start('Génération de la classe listant les constantes de privilèges');


$form = new \UnicaenCode\Form\CustomForm();

if (empty($params = $cg->formPublish($form))) return;


$sPrivileges = Util::getContainer()->get('UnicaenAuth\Service\Privilege');
/* @var $sPrivileges \UnicaenAuth\Service\PrivilegeService */

$privileges = $sPrivileges->getList();

$privilegesConsts = [];
$constMaxLen      = 0;
foreach ($privileges as $privilege) {
    $value = var_export($privilege->getFullCode(), true);
    $const = strtoupper($privilege->getFullCode());
    $const = str_replace(['-', ' '], ['_', '_'], $const);
    if (strlen($const) > $constMaxLen) $constMaxLen = strlen($const);

    if (!defined(\UnicaenAuth\Provider\Privilege\Privileges::class . '::' . $const)) {
        $privilegesConsts[$const] = $value;
    }
}

asort($privilegesConsts);

$data = '';
foreach ($privilegesConsts as $const => $value) {
    if ('' !== $data) $data .= "\n";
    $data .= "    const " . str_pad($const, $constMaxLen) . " = $value;";
}


$params['template']   = 'Privileges';
$params['privileges'] = $data;
$params['filename']   = 'module/Application/Provider/Privilege/Privileges.php';

$cg->end($params);