<?php

namespace UnicaenCode\Form;

class Service extends AbstractForm
{
    public function init()
    {
        $this->addText(
            'class', 'Classe du service', 'Application\Service\ExempleService'
        );

        $this->addCheckbox(
            'awareTrait', 'Générer un trait', true
        );

        $this->addCheckbox(
            'awareInterface', 'Générer une interface', false
        );

        $this->addCheckbox(
            'useGetter', 'Générer des getters dans les traits et les interfaces', true
        );

        $this->addCheckbox(
            'factory', 'Générer une factory', true
        );

        $this->addCheckbox(
            'subDir', 'Les traits, interfaces et Factory seront placés dans des sous-dossiers dédiés', false
        );
    }



    public function getParams(): array
    {
        $params = [
            'generator' => 'Service',
            'class'     => $this->get('class')->getValue(),
            'useGetter' => $this->get('useGetter')->getValue(),
            'subDir'    => $this->get('subDir')->getValue(),
        ];
        if ($this->get('awareTrait')->getValue()) {
            $params['awareTrait'] = [];
        }
        if ($this->get('awareInterface')->getValue()) {
            $params['awareInterface'] = [];
        }
        if ($this->get('factory')->getValue()) {
            $params['factory'] = [];
        }

        return $params;
    }
}